/**
 * TestExpert
 */
#include <stddefine.mqh>
int   __INIT_FLAGS__[];
int __DEINIT_FLAGS__[];
#include <stdlib.mqh>
#include <history.mqh>

#include <core/expert.mqh>


///////////////////////////////////////////////////////////////////// Configuration /////////////////////////////////////////////////////////////////////

extern string Parameter = "dummy";

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


string equitySymbol  = "TEST.EA";
string eaDescription = "Test Expert Adviser";


/**
 * MT4 start() function
 *
 * @return int - error status
 */
int onTick() {
   Strategy();
   RecordEquity();
   return(last_error);
}


/**
 * Strategy main function
 *
 * @return int - error status
 */
int Strategy() {
   // do something useful...
   return(last_error);
}


/**
 * Records the equity graph of a test
 *
 * @return bool - success status
 */
bool RecordEquity() {
   if (__STATUS_ERROR) return(false);
   if (!IsTesting())   return( true);

   static int hHst;
   if (!hHst) {
      string symbol = StringConcatenate(ifString(IsTesting(), "_", ""), equitySymbol);

      hHst = FindHistory(symbol);
      if (hHst > 0) {
         if (!ResetHistory(hHst))
            return(!SetLastError(hstlib_GetLastError()));
      }
      else {
         int error = hstlib_GetLastError();
         if (IsError(error))
            return(!SetLastError(error));

         hHst = CreateHistory(symbol, eaDescription, 2);
         if (hHst <= 0)
            return(!SetLastError(hstlib_GetLastError()));
      }
   }

   double value = AccountEquity() - AccountCredit();

   if (History.AddTick(hHst, Tick.Time, value, HST_CACHE_TICKS))
      return(true);
   return(!SetLastError(hstlib_GetLastError()));
}
